import bpy

#-----------------------------------

class NOXCameraProps(bpy.types.PropertyGroup):
    active = bpy.props.BoolProperty(
        name = "Camera active", 
        description = "Render this camera view", 
        default = False
    )
    dof_on = bpy.props.BoolProperty(
        name = "DOF Enabled", 
        description = "Enable depth of field", 
        default = False
    )
    aperture = bpy.props.FloatProperty(
        name = "Aperture",
        description = "Aperture",
        default = 4.0,
        min = 1.0,
        max = 36.0
    )
    iso = bpy.props.IntProperty(
        name = "ISO",
        description = "",
        default = 100,
        min = 1,
        max = 3200
    )
    shutter = bpy.props.FloatProperty(
        name = "Shutter",
        description = "Shutter [1/s]",
        default = 50.0,
        min = 0.02,
        max = 8000.0
    )

    ap_num_blades = bpy.props.IntProperty(
        name = "Blades number",
        description = "Iris number of blades",
        default = 5,
        min = 5,
        max = 15
    )
    ap_angle = bpy.props.FloatProperty(
        name = "Angle",
        description = "Iris angle",
        default = 0.0,
        min = 0.0,
        max = 360.0
    )
    ap_round_blades = bpy.props.BoolProperty(
        name = "Round blades", 
        description = "Iris round blades", 
        default = False
    )
    ap_blades_radius = bpy.props.FloatProperty(
        name = "Blades radius",
        description = "Iris blades round radius",
        default = 1.0,
        min = 1.0,
        max = 10.0
    )

    bokeh_ring_balance = bpy.props.IntProperty(
        name = "Ring balance",
        description = "Bokeh ring balance",
        default = 0,
        min = -1,
        max = 20
    )
    bokeh_ring_size = bpy.props.IntProperty(
        name = "Ring size",
        description = "Bokeh ring size",
        default = 20,
        min = 0,
        max = 100
    )
    bokeh_flatten = bpy.props.IntProperty(
        name = "Flatten",
        description = "Bokeh flatten",
        default = 0,
        min = 0,
        max = 100
    )
    bokeh_vignette = bpy.props.IntProperty(
        name = "Vignette",
        description = "Bokeh vignette",
        default = 0,
        min = -50,
        max = 50
    )

#-----------------------------------
