import bpy
from render_nox.material.material_props import NOXTextureSlotProps
from render_nox.material.material_props import NOXMatLayerProps
from render_nox.material.material_props import NOXMaterialProps

#-----------------------------------

def getCorrectTexID(texname, texID):
    if type(texname)!=str:
        #print("error")
        return -1
    if texname=='':
        #print("empty tex name")
        return -1
    if texID>-1  and  texID<bpy.data.textures.__len__():
        if bpy.data.textures[texID].name==texname:
            #print("returning same tex id "+str(texID))
            return texID

    for i in range(bpy.data.textures.__len__()):
        if (bpy.data.textures[i].name==texname):
            #print("wrong tex id, returning"+str(i))
            return i
    #print("tex named "+texname+" not found")
    return -1

#-----------------------------------
    
class TestMatPanel(bpy.types.Panel):
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_idname = "Mat_test_1"
    bl_label = "NOX Material"
    bl_context = "material"
    COMPAT_ENGINES = {}


    def draw(self, context):

        #row = self.layout.row()
        #row.template_image(context.material.noxData, "rough")
                
        #sima = context.space_data
        #iuser = sima.image_user
        #tex = context.material.texture_slots[0].texture
        #tex = context.texture
        #row.template_image(tex, "image", tex.users_material[0])
        
        #row = self.layout.row()
        #row.template_list(context.material, "texture_slots", context.material.noxData, "lay_index")
        
        
        #row = self.layout.row()
        #tex = context.material.testtex
        #row.template_preview(tex)
        #row.template_image(tex, "image", tex.users_material[0])
        
        obj = context.material
        if not obj:
            return
        
        row = self.layout.row()
        row.operator("wm.buttonrunnoxmateditor")
        row = self.layout.row()
        row.operator("wm.buttonimportnoxmaterial")
        row.operator("wm.buttonexportnoxmaterial")
        self.layout.separator()

        

        #if context.material.noxData.preview_id > -1:
        #    img = bpy.data.images[context.material.noxData.preview_id]
        #    row = self.layout.row()
            #row.template_ID(bpy.data.images, img.name)
            #row.template_preview(img)
            
            #row.template_image(bpy.data.images, img.name)
            
        
        
        row = self.layout.row()
        #row.template_list(obj.noxData, "layers", obj.noxData, "lay_index")
        row.template_list("UI_UL_list", "wtf1", obj.noxData, "layers", obj.noxData, "lay_index")

        col = row.column(align=True)
        col.operator("matlayer.add_remove", icon="ZOOMIN", text="")
        col.operator("matlayer.add_remove", icon="ZOOMOUT", text="").add = False
       
        #split = self.layout.split()
        self.layout.separator()

       
        if obj.noxData.layers:
            entry = obj.noxData.layers[obj.noxData.lay_index]
            #row = self.layout.row()
            self.layout.row().prop(entry, "weight")
            self.layout.row().prop(entry, "rough")
            self.layout.row().prop(entry, "refl0")
            subrefl90 = self.layout.row()
            subrefl90.enabled = not entry.refl_linked
            subrefl90.prop(entry, "refl90")
            self.layout.row().prop(entry, "refl_linked")
            self.layout.row().prop(entry, "ior")
            self.layout.row().prop(entry, "anisotropy")
            self.layout.row().prop(entry, "aniso_angle")
            self.layout.row().prop(entry, "transmission")
            sub_tr = self.layout.column()
            sub_tr.enabled = entry.transmission
            sub_tr.row().prop(entry, "transm_col")
            sub_tr.row().prop(entry, "absorption")
            sub_abs = sub_tr.row()
            sub_abs.enabled = entry.absorption
            sub_abs.row().prop(entry, "absorption_color")
            sub_abs.row().prop(entry, "absorption_distance")

            sub_disp = sub_tr.row()
            sub_disp.prop(entry, "dispersion")
            sub_disp2 = sub_disp.row()
            sub_disp2.enabled = entry.dispersion
            sub_disp2.prop(entry, "dispersion_size")
            sub_fglass = sub_tr.row()
            if entry.rough == 0:
                sub_fglass.enabled = True
                sub_disp.enabled = True
            else:
                sub_fglass.enabled = False
                sub_disp.enabled = False
            sub_fglass.prop(entry, "fake_glass")

            self.layout.row().prop(entry, "sss_on")
            sub_sss = self.layout.row()
            sub_sss.enabled = entry.sss_on
            sub_sss.prop(entry, "sss_density")
            sub_sss.prop(entry, "sss_coll_dir")
            
            self.layout.separator()
        self.layout.prop(obj.noxData, "opacity")
        if obj.noxData.layers:
            self.layout.separator()
            row = self.layout.row()
            #col = row.column(align=True)
            row.prop(entry, "emission")
            #col = row.column(align=True)
            row.prop(obj.noxData, "skyportal")
            self.layout.prop(entry, "emission_color")
            self.layout.prop(entry, "emission_power")
            self.layout.prop(entry, "emission_unit")
            self.layout.prop(entry, "ies_file")
            self.layout.separator()
        self.layout.prop(obj.noxData, "blend_layer")

        self.layout.separator()
        self.layout.row().prop(obj.noxData, "displ_continuity")
        self.layout.row().prop(obj.noxData, "displ_ignore_scale")
        self.layout.row().prop(obj.noxData, "displ_depth")
        self.layout.row().prop(obj.noxData, "displ_shift")
        self.layout.row().prop(obj.noxData, "displ_normal_mode")
        self.layout.row().prop(obj.noxData, "displ_subdivs")
        
        row = self.layout.row()
        row.enabled = False
        #row.label(text=context.scene.noxData.blend_layers[obj.noxData.blend_layer])
        #row.prop(context.scene.noxData.blend_layers, obj.noxData.blend_layer, text="")
            
        #self.layout.template_preview(id=bpy.data.images[obj.noxData.preview_id])
        #self.layout.template_preview(id=obj)

        #row = self.layout.row()
        #imagename="prev_mat_"+obj.name
        #row.template_preview(id=bpy.data.images[imagename], show_buttons=False)
     
    @classmethod
    def poll(cls, context):
        return (context.object is not None) and (context.scene.render.engine == 'nox_renderer')

#-----------------------------------

class NOXTexturePanel(bpy.types.Panel):
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_idname = "Mat_test_2"
    bl_label = "NOX Textures"
    bl_context = "material"
    COMPAT_ENGINES = {"nox_renderer"}

    def draw(self, context):
        mat = context.material

        if not mat:
            return
        if mat.noxData.layers.__len__()<1 or mat.noxData.layers.__len__()<=mat.noxData.lay_index:
            return
        layer = mat.noxData.layers[mat.noxData.lay_index]
        
        if layer.textures=="refl0":
            tslot = layer.tex_refl0
        if layer.textures=="refl90":
            tslot = layer.tex_refl90
        if layer.textures=="rough":
            tslot = layer.tex_rough
        if layer.textures=="light":
            tslot = layer.tex_light
        if layer.textures=="weight":
            tslot = layer.tex_weight
        if layer.textures=="normal":
            tslot = layer.tex_normal
        if layer.textures=="opacity":
            tslot = mat.noxData.tex_opacity
        if layer.textures=="displacement":
            tslot = mat.noxData.tex_displacement
        if layer.textures=="transm":
            tslot = layer.tex_transm
        if layer.textures=="anisotropy":
            tslot = layer.tex_aniso
        if layer.textures=="aniso_angle":
            tslot = layer.tex_aniso_angle
            
        
        row = self.layout.row()
        row.label(text="Selected material layer: Layer "+str(mat.noxData.lay_index+1))
        
        row = self.layout.row()

        col = row.column(align=True)
        #col = self.layout.column(align=True)
        col.label(text="Texture slot:")
        col.prop(layer, "textures", expand=True)
        
        col = row.column(align=True)
        col.label(text="Options:")
        col.prop(tslot, "enabled")
        col.prop(tslot, "bilinear")
        #row = self.layout.row()
        #row.prop(tslot, "enabled")
        
        self.layout.separator()
        row = self.layout.row()
        row.label(text="Choose texture:")

        row = self.layout.row()

        col = row.column(align=True)
        #col.template_list(bpy.data, "textures", tslot, "texID")
        col.template_list("UI_UL_list", "wtf2", bpy.data, "textures", tslot, "texID")

        
        #row = self.layout.row()
        #row.prop(tslot, "texID")


        col = row.column(align=True)
        
        #row = self.layout.row()
        col.operator("material.add_nox_image_texture")

        cTexID = getCorrectTexID(tslot.tex_name, tslot.texID)
        #tslot.texID = cTexID
        
        
        if cTexID<0:
        #if tslot.texID<0:
            col.label(text="No texture chosen")
            #pass
        else:
            col.operator("material.uncheck_tex_in_nox_slot")
            col.operator("material.delete_tex_permanently")
            #tex = bpy.data.textures[tslot.texID]
            tex = bpy.data.textures[cTexID]
            if hasattr(tex, "image_user") and tex.type=="IMAGE":
                row1 = self.layout.row()
                col1 = row1.column()
                
                if hasattr(tex.image, "filepath"):
                    col1.template_image(tex, "image", tex.image_user, compact=True)
                else:
                    col1.template_image(tex, "image", tex.image_user, compact=False)
                    

                row1 = self.layout.row()
                #mat.active_texture = tex
                #row.template_preview(id=tex)
                row1.template_preview(id=bpy.data.textures[cTexID], show_buttons=False)
            else:
                col.operator("material.change_tex_type_to_image")
                col.label(text="Not an image texture")
            

        
        
        
#        self.layout.separator()
        row = self.layout.row()
        row.label(text="Modifiers:")
        
        if layer.textures=="normal":
            row = self.layout.row()
            row.prop(tslot, "normal_power")
            row = self.layout.row()
            row.prop(tslot, "normal_invert_x")
            row.prop(tslot, "normal_invert_y")
        else:
            row = self.layout.row()
            col = row.column(align=True)
            col.prop(tslot, "brightness")
            col.prop(tslot, "contrast")
            col.prop(tslot, "saturation")
            col.prop(tslot, "hue")
            col.prop(tslot, "invert")
            col = row.column(align=True)
            col.prop(tslot, "red")
            col.prop(tslot, "green")
            col.prop(tslot, "blue")
            col.prop(tslot, "gamma")
        
        #row = self.layout.row()
        #row.prop(tslot, "bilinear")

    @classmethod
    def poll(cls, context):
        return (context.object is not None) and (context.scene.render.engine == 'nox_renderer')
